define AzEl_from_RAdec()
%!%+
%\function{AzEl_from_RAdec}
%\synopsis{computes horizontal (azimut, elevation) coordinates from a point's (RA, dec) at a time MJD}
%\usage{(az, el) = AzEl_from_RAdec(RA, dec, MJD,  longw, lat);}
%\description
%    This function is deprecated. Please use equatorial2horizon instead.
%\seealso{equatorial2horizon,horizon2equatorial}
%!%-
{
  variable RA, dec, MJD, longw, lat;
  switch(_NARGS)
  { case 5: (RA, dec, MJD, longw, lat) = (); }
  { help(_function_name()); return; }

  RA = angle_to_rad(RA; unit="hms");
  dec = angle_to_rad(dec; unit="deg");

  variable az,el;

  (az,el)=equatorial2horizon(RA,dec;lat=lat*PI/180.,lon=longw*PI/180.,JD=MJD,mjd);
  
  return az*180./PI, el*180./PI;
}
