require("pcre"); 

define X11color2rgb(searchname) {
%!%+
%\function{X11color2rgb}
%\synopsis{return rgb value for x11's rgb.txt}
%\usage{variable rgb=X11color2rgb(colorname)}
%\qualifiers{
%\qualifier{rgbfile}{File defining the colors, default: /usr/share/X11/rgb.txt}
%}
%\description
%This function returns the integer specifying the rgb code of a color
%named in the file rgb.txt accompanying the X11 distribution.
%\seealso{xfig_lookup_w3c_color}
%!%-
    variable rr,gg,bb,name;
    variable rgbfile=qualifier("rgbfile","/usr/share/X11/rgb.txt");
    variable exists=stat_file(rgbfile);
    if (exists==NULL) {
	throw OpenError,"X11 rgb file "+rgbfile+" does not exist";
    }

    variable lin;
    variable pcre=pcre_compile("(\\d+)\\s*(\\d+)\\s*(\\d+)\\s*([ a-zA-Z0-9]*)");
    variable fp=fopen(rgbfile,"r");
    % skip 1st line
    ()=fgets(&lin,fp);

    while (fgets(&lin,fp)>0) {
	lin=substr(lin,1,strlen(lin)-1);
	variable res=pcre_exec(pcre,lin);
	name=pcre_nth_substr(pcre,lin,4);

	if (name==searchname) {
	    rr=integer(pcre_nth_substr(pcre,lin,1));
	    gg=integer(pcre_nth_substr(pcre,lin,2));
	    bb=integer(pcre_nth_substr(pcre,lin,3));
	    ()=fclose(fp);
	    return((rr<<16)|(gg<<8)|bb);
	}
    }
    ()=fclose(fp);
    throw RunTimeError,"No color named "+searchname+" exists";
    % not that this is ever reached
    return -1;
}
