define wavelength_to_rgb()
%!%+
%\function{wavelength_to_rgb}
%\synopsis{computes the color values of visual light}
%\usage{Integer_Type[] wavelength_to_rgb(Double_Type lambda[]);}
%\description
%    \code{380 <= lambda <= 780} is the wavelength in nm.
%    The return value is its 24bit RGB color value.
%
%    The conversion is performed after the code by Dan Bruton,
%    see http://www.physics.sfasu.edu/astro/color.html.
%!%-
{
  variable lambda;
  switch(_NARGS)
  { case 1: lambda = (); }
  { return help(_function_name()); }

  variable i, sss, eightbit=255.99999, R=Integer_Type[length(lambda)], G=@R, B=@R;
  i = where(380 <= lambda < 420);
    sss = .3 + .7*(lambda[i]-380.)/(420-380);
    R[i] = int(eightbit*(440.-lambda[i])/(440-380)*sss);
  % G[i] = 0;
    B[i] = int(eightbit*sss);
  i = where(420 <= lambda < 440);
    R[i] = int(eightbit*(440.-lambda[i])/(440-380));
  % G[i] = 0;
    B[i] = 255;
  i = where(440 <= lambda < 490);
  % R[i] = 0;
    G[i] = int(eightbit*(lambda[i]-440.)/(490-440));
    B[i] = 255;
  i = where(490 <= lambda < 510);
  % R[i] = 0;
    G[i] = 255;
    B[i] = int(eightbit*(510.-lambda[i])/(510-490));
  i = where(510 <= lambda < 580);
    R[i] = int(eightbit*(lambda[i]-510.)/(580-510));
    G[i] = 255;
  % B[i] = 0;
  i = where(580 <= lambda < 645);
    R[i] = 255;
    G[i] = int(eightbit*(645.-lambda[i])/(645-580));;
  % B[i] = 0;
  i = where(645 <= lambda < 700);
    R[i] = 255;
  % G[i] = 0;
  % B[i] = 0;
  i = where(700 <= lambda < 780);
    sss = .3 + .7*(780.-lambda[i])/(780-700);
    R[i] = int(eightbit*sss);
  % G[i] = 0;
  % B[i] = 0;
  variable RGB = R*0x010000 + G*0x0100 + B;
  return (typeof(lambda)==Array_Type ? RGB : RGB[0]);
}
