%%%%%%%%%%%%%%%%%%%
define strftime_MJD()
%%%%%%%%%%%%%%%%%%%
%!%+
%\function{strftime_MJD}
%\synopsis{formats an Modified Julian Date as a string}
%\usage{String_Type strftime_MJD([String_Type fmt,] Double_Type MJD)}
%\description
%    If \code{fmt} is not specified, \code{"%Y-%m-%d, %H:%M:%S"} is assumed.
%\seealso{strftime, gmtime, MJD2UNIXtime}
%!%-
{
  variable fmt="%Y-%m-%d, %H:%M:%S", MJD;
  switch(_NARGS)
  { case 1: MJD = (); }
  { case 2: (fmt, MJD) = (); }
  { help(_function_name()); return; }
  
  if(typeof(MJD)==Array_Type)
    return array_map(String_Type, &strftime, fmt, array_map(Struct_Type, &gmtime, MJD2UNIXtime(MJD)));

  
  return strftime(fmt,gmtime( MJD2UNIXtime(MJD)));
}
